#include <ros/ros.h>
#include <iostream>
#include <math.h>

#include <std_msgs/Float32.h>
#include <geometry_msgs/Twist.h>
#include <sensor_msgs/Joy.h> 

using namespace std;

int counter = 0;
int Count_recte = 0;
int Count_gir = 0;

int totalCount = 0;
int t = 0;
int tim = 100;
//int total = 4300;

int turns = 0;

bool turnFlag = false;
bool turnFinished = false;
int terrain_type = 1;

bool gostraight = true;
int travelled = 0;

bool recte = true;


void Enc_Right_Callback(const std_msgs::Float32& msg){
    counter = msg.data;
}

void terrainCallback(const std_msgs::Float32& msg){
    terrain_type = msg.data;
}

void joyCallback (const sensor_msgs::Joy::ConstPtr& joy_data){
/* This function responds to any change on the state of the joystick. It
 * is mainly used to detect when the buttons are pressed and act according
 * the one that has been pressed
 */
	if (joy_data->buttons[4] == 1){	
		turnFlag = true;
		cout <<  "Boto 5: activa" << endl;
	}
	if (joy_data->buttons[3] == 1){	
		turnFlag = false;
		cout <<  "Boto 4: desactiva" << endl;
	}
}

void temps(){
	if (t < tim){
		t++;
		Count_recte = Count_recte + counter;
		//cout << "Counter: " << counter << " totalCounter en recte: " << Count_recte << endl;
		
	}
	if (t == tim){
		t = 0;
		recte = false;
		Count_recte = 0;
	}
}
/*void gir(){
	
	float threshold;
	int totalpulse = 2100;
	
	Count_gir = Count_gir + counter;
	cout << "Counter: " << counter << " totalCounter girant: " << Count_gir << endl;
	threshold = totalpulse*2.99;
				
	
	//if (Count_gir > threshold){
	if (Count_gir > threshold){	
		cout << " totalCounter girant: " << Count_gir << endl;
		recte = true;
	}
}*/
void gir(){
	
	float threshold;
	int totalpulse = 5750;
	
	Count_gir = Count_gir + counter;
	cout << "Counter: " << counter << " totalCounter girant: " << Count_gir << endl;
	//threshold = totalpulse*2.99;
	/*int totalpulse = 4980;
	cout << "Counter: " << counter << " totalCounter: " << totalCount << endl;
	totalCount = totalCount + counter;*/
	
	switch (terrain_type){
		
		case 1:
				threshold = totalpulse*2.05;
				break;
		case 2:
				threshold = totalpulse*2.16;
				break;
		case 3:
				threshold = totalpulse*2.91;
				break;
		case 4: 
				threshold = totalpulse*2.16;
				break;
		case 5:
				threshold = totalpulse*2.09;
				break;
		case 6: 
				threshold = totalpulse*2.059;
				break;
		case 7: 
				threshold = totalpulse*2.05;
				break;
		case 8: 
				threshold = totalpulse*2.15;
				break;
		case 9: 
				threshold = totalpulse*2.15;
				break;
	}
	
	if (totalCount > threshold){
		turnFinished = true;
	}
}

int main(int argc, char** argv){

	ros::init(argc, argv, "circuit");
	ros::NodeHandle h;
	
	ros::Subscriber I_fl = h.subscribe("Encoder_Right", 100, Enc_Right_Callback);
	ros::Subscriber joy_sub = h.subscribe("joy",0,joyCallback);
	
	ros::Publisher speed = h.advertise<geometry_msgs::Twist>("cmd_vel",0);
    geometry_msgs::Twist cmd_vel;Count_gir = 0;
    
    ros::Rate loop_rate(20);
    
     while (ros::ok()){
		
		if(turnFlag){
			if (recte){
				cmd_vel.linear.x = 0.4;
				cmd_vel.angular.z = 0;
				speed.publish(cmd_vel);
				temps();
				//cout <<  "Recte" << endl;
			}
			else {
				cmd_vel.linear.x = 0;
				cmd_vel.angular.z = -0.4;
				speed.publish(cmd_vel);
				//cout <<  "girant" << endl;
				gir();
				if (recte){
					turns = turns + 1;
					Count_gir = 0;
					cout <<  "Girs fets: " << turns << endl;
				}
			}
			if(turnFlag == false){
				cmd_vel.linear.x = 0;
				cmd_vel.angular.z = 0;
				speed.publish(cmd_vel);
			}
			if (turns == 4){
				turns = 0;
				cmd_vel.linear.x = 0;
				cmd_vel.angular.z = 0;
				speed.publish(cmd_vel);
				turnFlag = false;
				
				cout <<  "fi" << endl;
			}
				
		}     
		ros::spinOnce();
        loop_rate.sleep();
    
    
    }
    return 0;
}
